#!/bin/sh
#
#Copyright 2010 Konstantin Nadezhdin (nk_rec AT mail DOT ru)
#
#This program is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 3 of the License, or
#(at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#Version: 1.3 (2010-09-30 16:15:06)
#
#Description:

progname="${0##*/}"
menusize="26 120 22"
menusizel="16 80 8"
msgsize="20 120"
msgsizel="10 80"
fn=""; fk=""
title="Управление:"

menu_t(){
	#$1 - $title
	#$2 - $menutitle
	#$3 - $menusize
	#$4 - $menulist
	#$5 - $options
	tmpfile="/tmp/input-$UID.$$"
	dialog --backtitle "$progname:$title" --title "$1" $5 --menu "$2" $3 $4 2>$tmpfile
	ret=$?
	read < $tmpfile
	rm -f $tmpfile
	action="$REPLY"
}

input_t(){
	#$1 - $title; #$2 - $inputboxtitle; #$3 - $inputboxsize; #$4 - $inputboxdef; #$5 - $options
	tmpfile="/tmp/input-$UID.$$"
	dialog --backtitle "$progname:$title" --title "$1" $5 --inputbox "$2" $3 "$4" 2>$tmpfile
	ret=$?
	read < $tmpfile
	rm -f $tmpfile
	action="$REPLY"
}

echo_t(){
	#$1 - $title
	#$2 - $msgtext
	#$3 - $msgsize
	dialog --backtitle "$progname:$title" --title "$1" --msgbox "$2" $3
}

echo_ () {
	dialog --backtitle "$progname:$title" --title "$1" --infobox "$2" $3
}

ShowHelp () {
	echo_ " Справка " "Используй: $progname [-n SERVERNAME] [-k|-U \"DOMAIN\\login%password\"] [-h]\
		\n      -n - Имя компьютера или IP\
		\n      -k - использовать kerberos\
		\n      -U - использовать указанные \"DOMAIN\\login%password\"\
		\n      -h - вывести справку\n" "$msgsize"
}

for i in $@; do
	case $i in
		-n) nexts="fn";;
		-U) nexts="fU";;
		-k) fk="-k";;
		-h) ShowHelp; exit 0;;
		*)
			case $nexts in
				fn) fn="$i"; nexts="";;
				fU) fk="-U $i"; nexts="";;
			esac
		;;
	esac
done

if [ "$fn" = "" ]; then
	complist=$(net ads search '(objectCategory=Computer)' cn 2>/dev/null | awk '/^cn:/ {print $2" <-" | "sort"}' | sed ':a; s/[:,]//g; /$/N; s/\n/ /; ta')
	menu_t " Выбор компьютера " "" "$menusize" ".. Ручной_ввод $complist"
	fn="$action"
	if [ "$fn" = ".." ]; then
		input_t " Выбор компьютера " "Ручной ввод компьютера" "$msgsize" ""
		fn="$action"
	fi
fi
test "$fn" != "" || { ShowHelp; exit 1; }
title="$title: $fn"

if [ "$fk" = "" ]; then
	defU="$fn\\\\Администратор%password"
	menu_t " Тип аутентификации " "" "$menusize" "-k использовать:kerberos -U использовать:DOMAIN\\login%password"
	fk="$action"
	if [ "$fk" = "-U" ]; then
		input_t " Тип аутентификации -U " "укажи: DOMAIN\\\\login%password" "$msgsize" "$defU"
		fk="-U $action"
	fi
fi
echo "$fk" | grep -Eq "^(-k|-U +[[:graph:]]+\\\[[:graph:]]+%[[:graph:]]+)$" || { ShowHelp; exit 1; }

servicelist(){
	srvcmenutitle="(пробелы заменены символом \"._\" )"
	srvclist=$(net rpc service list -S $fn $fk)
	ret=$?
	if [ $ret -eq 0 ]; then
		srvcmenulist=$(echo "$srvclist" | awk '{gsub(/ +/,"._"); sub(/(\._)+"/," ");sub(/"$/,""); gsub(/\._/,"_",$2); print}')
	else
		srvcmenulist="error Ошибка:$ret"
	fi
}

ofilelist(){
	oflsmenutitle=""
	oflslist=$(net rpc file -S $fn $fk)
	ret=$?
	if [ $ret -eq 0 ]; then
		oflsmenulist=$(echo "$oflslist" | awk '$1 ~ /^[0-9]+$/ {flid_user=$1":"$2;sub($1" +"$2" *","");gsub(/( +$|")/,"");gsub(/ +/,":");sub(/^$/,"-");print flid_user" "$0 | "sort -t : --key 2"}')
	else
		oflsmenulist="error Ошибка:$ret"
	fi
}

sharelist(){
	shrmenutitle="(пробелы заменены символом \"._\" )"
	shrlist=$(rpcclient -c netshareenumall $fk $fn)
	ret=$?
	if [ $ret -eq 0 ]; then
		shrmenulist=$(echo "$shrlist" | awk '$1 !~ /^(password|remark):/ {if ($1 == "netname:") {sub(/^netname: */,"");str=str",_;"$0",_";} else str=str";"$0} END {gsub(/ /,"._",str);gsub(/\t/,"",str);gsub(/,_;/," ",str);print str}')
	else
		shrmenulist="error Ошибка:$ret"
	fi
}

registrylist(){
	#$1 - $path
	regmenutitle="(пробелы заменены символом \"._\" )"
	if [ "$1" = "" ]; then
		regmenulist="HKLM: <-- HKCU: <-- HKCR: <-- HKU: <--"
	else
		reglist=$(net rpc registry enumerate "$1" -S $fn $fk)
		ret=$?
		if [ $ret -eq 0 ]; then
			regmenulist=".. <-- $(echo "$reglist" | awk '{if ($1 == "Keyname") {sub(/^Keyname\s*=\s*/,"");gsub(/ /,"._");print $0":Key <--";} else if ($1 == "Valuename") {sub(/^Valuename\s*=\s*/,"");gsub(/ /,"._");print $0":Val <--";} }')"
		else
			regmenulist=".. <-- error Ошибка:$ret"
		fi
	fi
}

registrylist_r(){
	#$1 - $path
	base=$1
	subkeys=${base// /._}
	subkeys_r=""
	while [ "$subkeys" != "" ]; do
		fsubkeys=""
		for subkey in $subkeys; do
			subkeys_r="$subkey $subkeys_r"
			#echo "${subkey//._/ }"
			ssubkeys="$(net rpc registry enumerate "${subkey//._/ }" -S $fn $fk | awk '$1 ~ /^Keyname$/ {sub(/^Keyname\s*=\s*/,"");gsub(/ /,"._");print "'$subkey'/"$0}')"
			test "$ssubkeys" != "" && fsubkeys="$ssubkeys $fsubkeys"
		done
		subkeys="$fsubkeys"
	done
}

yesno(){
	#$1 - $title
	#$2 - $msgtext
	#$3 - $msgsize
	#$4 - $defaultno
	defaultno=""
	test "$4" = "No" && defaultno="--defaultno"
	dialog $defaultno --backtitle "$progname:$title" --title "$1" --yesno "$2" $3
	sel=$?
	case $sel in
		0) ret=1 ;;
		1) ret=0 ;;
		255) ret=0 ;;
	esac
}

manageservice(){
	service=" "
	servicelist
	defaultitem=""
	while [ "$service" != "" ]; do
		menu_t " Список сервисов " "$srvcmenutitle" "$menusize" "$srvcmenulist" "$defaultitem"
		defaultitem="--default-item $action"
		service="${action//._/ }"
		test "$service" = "error" && service=""
		managesrvc=1
		while [ $managesrvc -eq 1 -a "$service" != "" ]; do
			menu_t " Управление сервисом " "$service" "$menusize" "status Показать_статус start Запустить stop Остановить"
			case $action in
				status)	msgtext=$(net rpc service status "$service" -S $fn $fk);;
				start) msgtext=$(net rpc service start "$service" -S $fn $fk 2>/dev/null || echo "Ошибка $?");;
				stop) msgtext=$(net rpc service stop "$service" -S $fn $fk 2>/dev/null || echo "Ошибка $?");;
				*) break;;
			esac
			test "$msgtext" != "" && echo_t " Управление сервисом: $service " "$msgtext" "$msgsize"
			managesrvc=1
		done
	done
}

manageofiles(){
	oflid_user=" "
	ofilelist
	defaultitem=""
	while [ "$oflid_user" != "" ]; do
		menu_t " Список открытых файлов " "$oflsmenutitle" "$menusize" "$oflsmenulist" "$defaultitem"
		defaultitem="--default-item $action"
		oflid_user="$action"
		test "$oflid_user" = "error" && oflid_user=""
		manageofls=1
		while [ $manageofls -eq 1 -a "$oflid_user" != "" ]; do
			menu_t " Управление открытым файлом " "id=${oflid_user%:*} user=${oflid_user#*:}" "$menusize" "user Показать_файлы_пользователя close Закрыть"
			case $action in
				user) msgtext=$(net rpc file user ${oflid_user#*:} -S $fn $fk);;
				close)
					yesno " Управление открытым файлом " "Действительно закрыть?\n$oflid_user" "$msgsizel" "No"
					if [ $ret -eq 1 ]; then
						msgtext=$(net rpc file close ${oflid_user%:*} -S $fn $fk || echo "Ошибка $?")
						ofilelist
						defaultitem=""
						manageofls=0
					else
						msgtext=""
					fi
				;;
				*) break;;
			esac
			test "$msgtext" != "" && echo_t " Управление открытым файлом: $oflid_user " "$msgtext" "$msgsize"
		done
	done
}

manageshares(){
	share=" "
	sharelist
	defaultitem=""
	while [ "$share" != "" ]; do
		menu_t " Список шар " "$shrmenutitle" "$menusize" "$shrmenulist" "$defaultitem"
		defaultitem="--default-item $action"
		share="${action//._/ }"
		test "$share" = "error" && share=""
		manageshrs=1
		while [ $manageshrs -eq 1 -a "$share" != "" ]; do
			menu_t " Управление шарой " "$share" "$menusize" "info Показать_информацию delete Удалить"
			case $action in
				info) msgtext=$(rpcclient -c "netsharegetinfo \"$share\"" $fk $fn);;
				delete)
					yesno " Управление шарой " "Действительно удалить?\n$share" "$msgsizel" "No"
					if [ $ret -eq 1 ]; then
						msgtext=$(net rpc share delete "$share" -S $fn $fk || echo "Ошибка $?")
						sharelist
						defaultitem=""
						manageshrs=0
					else
						msgtext=""
					fi
				;; 
				*) break;;
			esac
			test "$msgtext" != "" && echo_t " Управление шарой: $share " "$msgtext" "$msgsize"
		done
	done
}

manageregistry(){
	regpath=""
	registry=""
	registrylist "$regpath"
	defaultitem=""
	menuoptions="--extra-button --extra-label Действия --ok-label Открыть"
	while [ $ret -ne 1 ]; do
		menu_t " Управление веткой реестра " "$regmenutitle\n$regpath" "$menusize" "$regmenulist" "$menuoptions $defaultitem"
		defaultitem="--default-item $action"
		registry_type="${action//._/ }"
		regtype="${registry_type#*:}:$ret"
		registry=${registry_type%:*}
		test "$registry" = "error" && registry=""
		managereg=1
		while [ $managereg -eq 1 -a $ret -ne 1 ]; do
			case $regtype in
				*Key:0) action="goto";;
				*Val:0) action="info";;
				*:0) action="goto";;
				*Key:3) menu_t " Управление веткой реестра " "$regpath/$registry" "$menusize" "goto Перейти delete Удалить";;
				*Val:3) menu_t " Управление веткой реестра " "$regpath/$registry" "$menusize" "info Смотреть delete Удалить";;
				*:3) action="goto";;
			esac
			case $action in
				goto)
					msgtext=""
					if [ "$registry" = ".." ]; then
						if [ "$regpath" = "${regpath%/*}" ]; then
							defaultitem="--default-item $regpath:"
							regpath=""
						else
							registry=${regpath##*/}
							regpath="${regpath%/*}"
							defaultitem="--default-item ${registry// /._}:Key"
						fi
					else
						if [ "$regpath" = "" ]; then
							regpath="$registry"
						else
							regpath="$regpath/$registry"
						fi
						defaultitem=""
					fi
					registrylist "$regpath"
					managereg=0
				;;
				info) msgtext=$(net rpc registry getvalue "$regpath" "$registry" -S $fn $fk ); managereg=0;;
				delete)
					case ${regtype#*:} in
						Key)
							yesno " Управление веткой реестра " "Рекурсивное удаление: $regpath/$registry\nПродолжить?" "$msgsizel" "No"
							if [ $ret -eq 1 ]; then
								registrylist_r "$regpath/$registry"
								msgtext="Рекурсивное удаление:"
								for subkey in $subkeys_r; do
									net rpc registry deletekey "${subkey//._/ }" -S $fn $fk; ret=$?
									if [ $ret -eq 0 ]; then
										msgtext="$msgtext\nУдален: ${subkey//._/ }"
									else
										msgtext="$msgtext\nОшибка ($ret) удаления ${subkey//._/ }"
									fi
								done
							else
								msgtext=""
							fi
						;;
						Val)
							yesno " Управление веткой реестра " "Удаление: $regpath/$registry\nПродолжить? " "$msgsizel" "No"
							if [ $ret -eq 1 ]; then
								net rpc registry deletevalue "$regpath" "$registry" -S $fn $fk; ret=$?
								if [ $ret -eq 0 ]; then
									msgtext="Удален: $regpath/$registry"
								else
									msgtext="Ошибка ($ret) удаления $regpath/$registry"
								fi
							else
								msgtext=""
							fi
						;;
					esac
					registrylist "$regpath"
					defaultitem=""
					managereg=0
				;; 
				*) break;;
			esac
			test "$msgtext" != "" && echo_t " Управление веткой реестра:$regpath/$registry " "$msgtext" "$msgsize" 
		done
	done

}

manage=" "
while [ "$manage" != "" ]; do
	menutitle=""
        menulist="managesrvc Управление_сервисами manageofls Управление_открытыми_фалами manageshrs Управление_шарами managereg Управление_реестром"
        menu_t " Выбор действий " "$menutitle" "$menusize" "$menulist"
	manage="$action"
	case $manage in
		managesrvc) manageservice;;
		manageofls) manageofiles;;
		manageshrs) manageshares;;
		managereg) manageregistry;;
	esac
done
#echo_t "$title" "Работа завершена" "$msgsizel"
exit 0

