#!/bin/bash
#
#Copyright 2010 Konstantin Nadezhdin (nk_rec AT mail DOT ru)
#
#This program is free software: you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation, either version 3 of the License, or
#(at your option) any later version.
#
#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#Version: 1.0 (2010-09-20 12:37:13)
#
#Description:
# Консоль управления (выбор компьютера, вызов внешних модулей управления)

progname="${0##*/}"
title="Консоль управления"
vncadmin_param="-d"
useroncmp_param="-d -b 192.168.1.255"
menusize="20 100 15"
msgsize="20 100"

menu_t(){
	#$1 - $title; #$2 - $menutitle; #$3 - $menusize; #$4 - $menulist; #$5 - $options
	tmpfile="/tmp/input-$UID.$$"
	dialog --backtitle "$progname:$title" --title "$1" $5 --menu "$2" $3 $4 2>$tmpfile
	ret=$?
	read < $tmpfile
	rm -f $tmpfile
	action="$REPLY"
}

input_t(){
	#$1 - $title; #$2 - $inputboxtitle; #$3 - $inputboxsize; #$4 - $inputboxdef; #$5 - $options
	tmpfile="/tmp/input-$UID.$$"
	dialog --backtitle "$progname:$title" --title "$1" $5 --inputbox "$2" $3 "$4" 2>$tmpfile
	ret=$?
	read < $tmpfile
	rm -f $tmpfile
	action="$REPLY"
}

authtype(){
	defU="$fn\\\\Администратор%password"
	menu_t " Тип аутентификации " "" "$menusize" "-k использовать:kerberos -U использовать:DOMAIN\\login%password"
	fk="$action"
	if [ "$fk" = "-U" ]; then
		input_t " Тип аутентификации -U " "укажи: DOMAIN\\\\login%password" "$msgsize" "$defU"
		fk="-U $action"
	fi
}

complist=$(net ads search '(objectCategory=Computer)' cn 2>/dev/null | awk '/^cn:/ {print $2" <-" | "sort"}' | sed ':a; s/[:,]//g; /$/N; s/\n/ /; ta')
manage="1"
while [ "$manage" = "1" ]; do
	menu_t " Выбор компьютера " "" "$menusize" ".. Ручной_ввод $complist"
	test $ret -ne 0 && break
	fn="$action"
	if [ "$fn" = ".." ]; then
		input_t " Выбор компьютера " "Ручной ввод компьютера:" "$msgsize" ""
		test $ret -ne 0 && break
		fn="$action"
	fi
	# Выполнение
	menu_t " Выбор действий " "Что делать с $fn?" "$menusize" "vncadmin Удаленное_управление_рабочим_столом managecmp Управление_компьютером useroncmp Кто_на_компе"
	case $action in
		vncadmin) vncadmin.sh $vncadmin_param -n $fn;;
		managecmp) managecomp.sh -n $fn;;
		useroncmp) useroncomp.sh $useroncmp_param -I $fn;;
		*) break;;
	esac
done
exit 0

